#include "ti83plus.inc"
#include "mirage.inc"

#define Menuent Saferam1
#define Menuch Saferam1+1
#define turn Saferam1+2
#define 2p Saferam1+3
#define matches Saferam1+4
.org _UserMem

 ret
 .db $01
MirageOSbutton:
 .db %00000000, %00000000
 .db %00111011, %10111000
 .db %00111011, %10111000
 .db %00111011, %10111000
 .db %00101010, %10101000
 .db %00101010, %10101000
 .db %00101010, %10101000
 .db %00101010, %10101000
 .db %00101010, %10101000
 .db %00101010, %10101000
 .db %00101010, %10101000
 .db %00101010, %10101000
 .db %00101010, %10101000
 .db %00111011, %10111000
 .db %00000000, %00000000
MirageOSDesc:
 .db "Matches v1.0",0
Progstart:
    call DispTitle
MainMenu:
    B_CALL _GetCSC ; remove residue keypress
    ld hl, MM
    call Menu
    cp 3
    ret z
    cp 2
    jp z, GameInstructions
    cp 1
    jp z, Hallofame
;    cp 1
;    jp z, Linkplay
;    or a
;    jp z, GameStart

GameStart:
    sub a
    ld (2p), a
    ld (turn), a
    ld hl, WhoStarts
    call Menu
    cp 3
    jp z, MainMenu
    cp 2
    jp z, RandChoose
    cp 1
    jr z, Calcstart
YouStart:    
    ld a, 1
    ld (turn), a
CalcStart:
    call DrawArena
    call InitMatches
    call FastCopy
GameLoop:
    ld a, (turn)
    or a
    jr z, Calcsturn
    jp Yourturn
ContLoop:
    push af
    ld b, a
    push bc
    ld a, (matches)
    ld b, a
    ld a, 20
    sub b
    add a, a
    add a, a
    add a, 2
    pop bc
    push bc
    ld h, a
    ld l, 11h
    ld c, 4
    call IML
    call Fastcopy
    pop bc
    ld a, (matches)
    sub b
    ld (matches), a
    pop af
    B_CALL _SetXXOP1
    ld de, 2A02h
    ld (_pencol), de
    ld hl, CalcPlayed
    B_CALL _VPutS
    ld de, 3002h
    ld (_pencol), de
    B_CALL _VPutS
    ld de, 2A36h
    ld (_pencol), de
    B_CALL _DispOP1a
    ld a, (matches)
    B_CALL _SetXXOP1
    ld de, 3036h
    ld (_pencol), de
    B_CALL _DispOP1a
    ld a, (matches)
    dec a
    jp z, GameFinished
    ld a, (turn)
    xor 1
    ld (turn), a
    jr GameLoop

Calcsturn:
    ld de, 0802h
    ld (_pencol), de
    ld hl, Cturn
    B_CALL _VPutS
    ld b, 150
CalcFL:
    ei
    halt
    djnz CalcFL
    ld a, (matches)
    sub 4
    and 3
    jr z, CalcPlay3
    ld a, (matches)
    sub 3
    and 3
    jr z, CalcPlay2
    ld a, (matches)
    sub 2
    and 3
    jr z, CalcPlay1
    ld b, 3
    call iRandom
    inc a
    jp ContLoop
CalcPlay3:
    ld a,3
    jp ContLoop
CalcPlay2:
    ld a,2
    jp ContLoop
CalcPlay1:
    ld a,1
    jp ContLoop
    
YourTurn:
    ld de, 0802h
    ld (_pencol), de
    ld hl, Yturn
    B_CALL _VPutS
    call CSCWait
    ld b, 0
    cp 35h
    jr z, YouPlay1
    cp 33h
    jr z, YouPlay2
    cp 31h
    jr z, YouPlay3
    cp 0Fh
    jp z, MainMenu
    cp 37h
    call z, QuitToShell
    jr YourTurn
YouPlay3:
    inc b
YouPlay2:
    inc b
YouPlay1:
    inc b
    ld a, (matches)
    sub b
    ld a, b
    jr c, YourTurn
    jr z, YourTurn
    jp ContLoop

GameFinished:
    set fracDrawLFont, (iy+fontFlags)
    ld a, (turn)
    or a
    jr z, CalcWon
    ld hl, 25*256+17
    ld de, 35*256+80
    call Dialogbox
    ld de, 27*256+20
    ld (_pencol), de
    ld hl, YouWin
    B_CALL _VPutS
    res fracDrawLFont, (iy+fontFlags)
    call CSCWait
    ld hl, HSName
    ld a, (hl)
    cp '-'
    jr z, TakeHSN
    jp MainMenu
CalcWon:
    ld hl, 25*256+10
    ld de, 35*256+85
    call Dialogbox
    ld de, 27*256+13
    ld (_pencol), de
    ld hl, CalcWin
    B_CALL _VPutS
    res fracDrawLFont, (iy+fontFlags)
    call CSCWait
    jp MainMenu

TakeHSN:
    ld hl, HSname
    ld b, 10
    ld a, 32
Erasename:
    ld (hl), a
    inc hl
    djnz Erasename    
    B_CALL _ClrLCDFull
    B_CALL _HomeUp
    ld hl, HS
    set textinverse, (iy+textflags)
    B_CALL _PutS
    res textinverse, (iy+textflags)
    ld hl, Entername
    B_CALL _PutS
    ld de, 0005h
    ld (_currow), de
    ld hl, HSName
    call NameInput
    jp MainMenu

RandChoose:
    ld b,2 
    call irandom
    or a
    jp z, YouStart
    jp CalcStart
        
InitMatches:
    ld a, 20
    ld (matches), a
    ld hl, 0211h
    ld b, a
    ld c, 4
IML:
    push hl
    push bc
    ld ix, Match
    ld c, 1
    ld b, 24
    call largespritehl
;    call fastcopy
    pop bc
    pop hl
    ld a, h
    add a, c
    ld h, a
    djnz IML
    ret


DrawArena:
    ld hl, _plotSScreen
    ld de, _plotSScreen + 1
    ld bc, 767
    sub a
    ld (hl), a
    ldir
    ld hl, _plotSScreen
    ld de, _plotSScreen + 1
    ld bc, 12*8-1
    dec a
    ld (hl), a
    ldir
    call FastCopy
    set fullscrndraw, (iy+apiflg4)
;    ld hl, 0000h
;    ld de, 3F5Fh
    B_CALL _HomeUp
    set textinverse, (iy+textflags)
    ld hl, MM+1
    B_CALL _PutS
    res textinverse, (iy+textflags)
    ld h,1
    ld bc, 0*256+63
    ld de, 0*256+0
    bcall(_ILine)
    ld bc, 95*256+63
    ld de, 95*256+0
    bcall(_ILine)
    ld bc, 82*256+6
    ld de, 82*256+63-8
    bcall(_ILine)
    ld bc,0*256+63-15
    ld de,82*256+63-15
    bcall(_ILine)
    ld bc,0*256+6
    ld de,95*256+6
    bcall(_ILine)
    ld bc,0*256+0      ; ILine - B=1st x coord
    ld de,0*256+6      ;         C=1st y coord
    bcall(_ILine)       ;         D=2nd x coord
    ld b,19            ;         E=2nd y coord
    ld d,b            ;         H=Style: 0-off,1-on,2-XOR
    bcall(_ILine)       ;
    ld b,38
    ld d,b
    bcall(_ILine)
    ld b,57
    ld d,b
    bcall(_ILine)
    ld b,76
    ld d,b
    bcall(_ILine)
    ld b,95
    ld d,b
    bcall(_ILine)
    ld a, 09h
    ld (_pencol), a
    ld a, 3Ah
    ld (_penrow), a
    ld a, '1'
    B_CALL _VPutMap
    ld a, 2Fh
    ld (_pencol), a
    ld a, '2'
    B_CALL _VPutMap
    ld a, 55h
    ld (_pencol), a
    ld a, '3'
    B_CALL _VPutMap
    ld hl, _plotSScreen
    B_CALL _SaveDisp
    ei
    ret
    
;Linkplay:
;    jp MainMenu

Hallofame:
    B_CALL _ClrLCDFull
    B_CALL _HomeUp
    ld hl, HS
    set textinverse, (iy+textflags)
    B_CALL _PutS
    res textinverse, (iy+textflags)
    B_CALL _NewLine
    B_CALL _PutS
    B_CALL _NewLine
    B_CALL _PutS
    call CSCWait
    jp MainMenu

GameInstructions:
    B_CALL _HomeUp
    ld hl, Helptext
    B_CALL _PutS
    call CSCwait
    jp MainMenu


CSCwait:
    ei
    halt
    B_CALL _GetCSC
    or a
    jr z, CSCwait
    ret
    
DispTitle:
    ld hl, TitlePic
    ld de, _plotSScreen
    call DispRLE
    call FastCopy
    ld hl, TP1
    ld de, _plotSScreen
    call DispRLE
    call FastCopy
    halt
    ld a, $FF
    out (1), a
    ld a, $00
    out (1), a
    in a, (1)
    inc a
    ret nz
    jr DispTitle

DialogBox:
    ; (h,l) = (y,x) upper left
    ; (d,e) = (y,x) lower right

 set plotLoc, (iy+plotFlags)    ; Draw only to the screen...
 push hl        ; Store for later
 push de        ; Store for later
 B_CALL _DrawRectBorderClear ; DrawRectangle and erase whatever is inside
 pop de     ;
 pop hl     ;
 push hl    ; Restore and resave the corrdinates
 push de    ; 
 inc d
 inc e
 B_CALL _DrawRectBorder  ; Draw another rectangel 1 pixel bigger at bottom right in both directions
 pop de     ; Restore coordinates again
 pop hl
 ld a,h
 xor 63         ; Needed because y=0 is bottom of screen, not top, for IPoint
 ld h,a         ; needed cause cannot xor h, 63
 ld a,d         ; store d,a for later
 xor 63         ; same as 2 prev lines
 ld b,l
 ld c,h
 ld d,0
 B_CALL _IPoint  ;(b,c) = (x,y xor 63) - upper left
 ld b,e
 B_CALL _IPoint
 inc b
 B_CALL _IPoint
 dec c
 B_CALL _IPoint
 ld c,a
 dec c
 B_CALL _IPoint
 ld b,l
 B_CALL _IPoint
 inc b
 B_CALL _IPoint
 dec b
 inc c
 B_CALL _IPoint
 ret

Menu:
    ld a, (hl)
    ld (Menuent), a
    inc hl
    push hl
    B_CALL _ClrLCDFull
    B_CALL _HomeUp
    pop hl
    set textinverse, (iy+textflags) 
    B_CALL _PutS
    res textinverse, (iy+textflags)
    push hl
    ld a, 0
    ld (Menuch), a
    jp MenuUD
MenuML:
    ei
    halt
    B_CALL _GetCSC
    or a
    jr z, MenuML
    cp skUp
    jr z, MenuUp
    cp skDown
    jr z, MenuDown
    cp sk2nd
    jr z, MenuDone
    jr MenuML
MenuUp:
    ld a, (Menuch)
    or a
    jr nz, MenuNF
    ld a, (Menuent)
MenuNF:
    dec a
    ld (Menuch), a
    jr MenuUD
MenuDown:
    ld a, (Menuent)
    ld b, a
    ld a, (Menuch)
    inc a
    cp b
    jr nz, MenuNL
    xor a
MenuNL
    ld (Menuch), a
    jr MenuUD
MenuUD:
    pop hl
    push hl
    ld de, 0002h
    ld (_currow), de
    ld a, (Menuent)
    ld c, 0
    ld b,a
MenuUDL:
    ld a, (Menuch)
    cp c
    call z, MenuSR
    push bc
    B_CALL _PutS
    pop bc
    call MenuRR
    inc c
    djnz MenuUDL
    jp MenuML
MenuDone
    pop hl
    ld a, (Menuch)
    ret
MenuSR:
    set textinverse, (iy+textflags)
    ret
MenuRR:
    res textinverse, (iy+textflags)
    ret
    
NameInput:
  ld b,0            ; B = number of letters entered so far

WaK:               ; A simple string input routine follows
 push hl
 bcall(_getcsc)
 cp $38
 jr z,BackSpace
 cp $09
 jr z,NameDone
 cp $11
 jr nz,CheckLetter
 ld a,32
 pop hl
 jr PutLetter
CheckLetter:
 ld hl,Letters
 push bc
 ld bc,26
 cpir
 ld d,c
 pop bc
 pop hl
 jr nz,WaK
 ld a,65
 add a,d
PutLetter:
 ld c,a
 ld a,b
 cp 10
 jr z,WaK
 ld (hl),c
 inc hl
 inc b
 ld a,c
 bcall(_putc)
 jr WaK
BackSpace:
 pop hl
 ld a,b
 or a
 jr z,WaK
 dec b
 dec hl
 push hl
 ld (hl),32
 ld hl,_curcol
 dec (hl)
 ld a,32
 bcall(_putc)
 dec (hl)
 pop hl
 jr WaK
NameDone:
 pop hl
 ret
 
Letters:
 .db $1A,$22,$2A,$0B,$13,$1B,$23,$2B,$0C,$14,$1C
 .db $24,$2C,$0D,$15,$1D,$25,$2D,$0E,$16,$1E,$26
 .db $2E,$1F,$27,$2F

; ********************************************** 
; ******************** Data ********************
; **********************************************
; Texts
YTurn:
.db "Your turn...   ",0
CTurn:
.db "Calc's turn...",0
YouWin:
.db "You Win :)",0
CalcWin:
.db "Calc wins :(",0
EnterName:
.db "You are the 1st "
.db "to have beaten  "
.db "the calc!  put  "
.db "your name here: ",0
CalcPlayed:
.db "Matches played:",0
.db "Matches left",6,6,"  :", 0

; Menu data
;   "0123456789ABCDEF"
MM:
.db 4
.db "  Matches v1.0  ",0
.db "   Start game   ",0
;.db "    2 player    ",0
.db "  Hall of fame  ",0
.db "  Instructions  ",0
.db "      Quit      ",0

WhoStarts:
.db 4
.db "   Who starts   ",0
.db "      you       ",0
.db "      calc      ",0
.db "     Random     ",0
.db "      back      ",0
; Highscore... well...have you beaten the calc
HS:
.db "   High Score   ",0
HSName:
.db "--No one--", 0
.db "is the first one"
.db "to have beaten  "
.db "the calc on this"
.db "calculator!", 0

; Help/instructions text
;   "0123456789ABCDEF"
HelpText:
.db "The point of the"
.db "game is to force"
.db "the other player"
.db "to remove the la"
.db "st match.At each"
.db "turn, you can pi"
.db "ck 1, 2, or 3 ma"
.db "tches. Good luck",0

; Match picture

Match:
.db %11100000
.db %11100000
.db %11100000
.db %11100000
.db %11100000
.db %10100000
.db %10100000
.db %10100000
.db %10100000
.db %10100000
.db %10100000
.db %10100000
.db %10100000
.db %10100000
.db %10100000
.db %10100000
.db %10100000
.db %10100000
.db %10100000
.db %10100000
.db %10100000
.db %10100000
.db %10100000
.db %11100000

; Title picture greyscale.. layer 1 + 2

TitlePic:

 .db $91,$00,$12,$02,$80,$91,$00,$0A,$04,$80,$91,$00
 .db $06,$60,$91,$00,$03,$08,$91,$00,$03,$06,$00,$04
 .db $C0,$E0,$00,$20,$00,$18,$91,$00,$03,$04,$60,$08
 .db $C0,$E0,$00,$30,$00,$18,$91,$00,$03,$04,$60,$10
 .db $E1,$40,$00,$30,$04,$10,$91,$00,$03,$0C,$40,$11
 .db $E1,$C0,$FC,$3C,$3A,$33,$81,$E1,$E0,$0C,$C0,$01
 .db $E2,$C1,$0C,$20,$22,$34,$82,$23,$10,$08,$40,$01
 .db $20,$C2,$18,$60,$40,$38,$86,$63,$00,$08,$C0,$01
 .db $34,$82,$18,$60,$C0,$31,$8C,$61,$80,$08,$80,$03
 .db $38,$86,$38,$60,$C0,$31,$8F,$80,$C0,$08,$80,$02
 .db $31,$86,$18,$60,$C0,$61,$8C,$00,$C0,$00,$00,$02
 .db $31,$84,$50,$60,$C2,$61,$0C,$00,$40,$00,$00,$44
 .db $21,$86,$90,$48,$C4,$61,$2C,$64,$40,$39,$80,$70
 .db $01,$87,$18,$60,$78,$61,$87,$87,$80,$11,$91,$00
 .db $07,$80,$91,$00,$0B,$88,$91,$00,$0A,$02,$78,$91
 .db $00,$0A,$04,$1C,$91,$00,$0B,$70,$91,$00,$09,$1C
 .db $03,$66,$91,$00,$09,$1C,$04,$34,$20,$91,$00,$07
 .db $28,$1E,$01,$C8,$50,$91,$00,$03,$80,$00,$00,$0D
 .db $78,$12,$02,$0A,$80,$00,$0D,$21,$40,$00,$00,$07
 .db $D8,$03,$00,$4E,$40,$00,$05,$63,$20,$00,$00,$2A
 .db $10,$04,$00,$40,$C0,$00,$06,$22,$60,$00,$10,$10
 .db $80,$04,$00,$04,$00,$00,$04,$29,$C0,$00,$18,$20
 .db $80,$02,$00,$04,$91,$00,$06,$08,$00,$80,$02,$00
 .db $06,$91,$00,$06,$08,$00,$40,$02,$00,$02,$91,$00
 .db $06,$08,$00,$40,$01,$00,$02,$91,$00,$06,$04,$00
 .db $40,$01,$00,$02,$91,$00,$06,$04,$00,$40,$01,$00
 .db $03,$91,$00,$06,$04,$00,$20,$01,$00,$01,$91,$00
 .db $06,$02,$00,$20,$00,$80,$01,$91,$00,$06,$02,$00
 .db $20,$00,$80,$00,$80,$91,$00,$07,$20,$00,$80,$01
 .db $80,$91,$00,$07,$10,$00,$40,$91,$00,$09,$10,$00
 .db $40,$91,$00,$45,$01,$C0,$91,$00,$07,$04,$00,$00
 .db $82,$91,$00,$08,$06,$00,$00,$C2,$91,$00,$08,$02
 .db $00,$00,$C4,$91,$00,$08,$02,$00,$00,$C4,$91,$00
 .db $08,$02,$00,$00,$E4,$00,$00,$60,$91,$00,$05,$02
 .db $72,$00,$64,$00,$00,$70,$91,$00,$05,$03,$92,$20
 .db $64,$00,$00,$D0,$91,$00,$05,$03,$12,$20,$64,$80
 .db $00,$90,$91,$00,$05,$02,$12,$20,$24,$00,$01,$30
 .db $00,$00,$EE,$88,$67,$02,$12,$62,$24,$38,$01,$20
 .db $00,$01,$04,$88,$88,$02,$22,$62,$64,$A0,$F1,$C0
 .db $00,$01,$04,$88,$88,$01,$E3,$42,$54,$A1,$99,$1E
 .db $3C,$01,$04,$88,$64,$00,$01,$C3,$9C,$A1,$09,$11
 .db $23,$81,$64,$88,$62,$00,$00,$41,$8C,$A1,$09,$11
 .db $20,$61,$24,$88,$81,$00,$02,$40,$04,$3E,$F1,$D9
 .db $A0,$21,$24,$88,$81,$00,$03,$40,$91,$00,$03,$6F
 .db $EF,$E0,$EE,$66,$6E,$00,$01,$C0,$91,$00,$15

TP1:

 .db $91,$00,$12,$03,$C0,$91,$00,$0A,$04,$80,$91,$00
 .db $06,$20,$91,$00,$03,$08,$91,$00,$03,$02,$20,$04
 .db $C0,$60,$00,$20,$00,$18,$91,$00,$03,$04,$60,$08
 .db $C0,$C0,$00,$30,$00,$10,$91,$00,$03,$0C,$60,$19
 .db $E1,$C0,$00,$30,$04,$30,$91,$00,$03,$0C,$40,$11
 .db $E1,$C0,$9C,$3C,$1A,$33,$81,$E1,$E0,$0C,$40,$01
 .db $62,$C1,$08,$20,$62,$34,$82,$23,$10,$08,$C0,$01
 .db $24,$C2,$08,$20,$40,$39,$84,$23,$00,$08,$80,$01
 .db $34,$86,$18,$60,$C0,$21,$84,$41,$80,$08,$80,$01
 .db $39,$86,$38,$60,$C0,$71,$8F,$81,$C0,$00,$80,$02
 .db $39,$84,$38,$60,$C0,$61,$8C,$00,$C0,$00,$00,$02
 .db $31,$84,$58,$40,$C0,$61,$8C,$00,$40,$00,$00,$44
 .db $21,$87,$92,$48,$C4,$61,$2C,$44,$40,$39,$80,$78
 .db $01,$07,$18,$70,$78,$41,$87,$0F,$80,$11,$91,$00
 .db $07,$08,$80,$91,$00,$0A,$74,$A0,$91,$00,$0A,$82
 .db $10,$91,$00,$09,$03,$E3,$91,$00,$0A,$07,$8F,$10
 .db $91,$00,$07,$01,$00,$08,$99,$70,$91,$00,$07,$20
 .db $00,$03,$C3,$C0,$91,$00,$05,$30,$05,$00,$00,$06
 .db $37,$91,$00,$04,$80,$00,$30,$02,$80,$0C,$01,$F1
 .db $40,$00,$19,$21,$40,$00,$30,$00,$00,$0C,$00,$B1
 .db $00,$00,$05,$61,$20,$00,$10,$01,$00,$04,$06,$17
 .db $00,$00,$06,$22,$40,$00,$10,$00,$80,$04,$02,$85
 .db $00,$00,$04,$69,$C0,$00,$18,$00,$80,$02,$00,$84
 .db $91,$00,$06,$08,$00,$80,$02,$00,$06,$91,$00,$06
 .db $08,$00,$40,$02,$00,$02,$91,$00,$06,$08,$00,$40
 .db $01,$00,$02,$91,$00,$06,$04,$00,$40,$01,$00,$02
 .db $91,$00,$06,$04,$00,$40,$01,$00,$03,$91,$00,$06
 .db $04,$00,$20,$01,$00,$01,$91,$00,$06,$02,$00,$20
 .db $00,$80,$01,$91,$00,$06,$02,$00,$20,$00,$80,$00
 .db $80,$91,$00,$07,$20,$00,$80,$01,$80,$91,$00,$07
 .db $10,$00,$40,$91,$00,$09,$10,$00,$40,$91,$00,$45
 .db $01,$C0,$91,$00,$07,$04,$00,$00,$82,$91,$00,$08
 .db $06,$00,$00,$C2,$91,$00,$08,$02,$00,$00,$C4,$91
 .db $00,$08,$02,$00,$00,$C4,$91,$00,$08,$02,$00,$00
 .db $E4,$00,$00,$60,$91,$00,$05,$02,$72,$00,$64,$00
 .db $00,$70,$91,$00,$05,$03,$92,$20,$64,$00,$00,$D0
 .db $91,$00,$05,$03,$12,$20,$64,$80,$00,$90,$91,$00
 .db $05,$02,$12,$20,$24,$00,$01,$30,$00,$00,$EE,$88
 .db $67,$02,$12,$62,$24,$38,$01,$20,$00,$01,$04,$88
 .db $88,$02,$22,$62,$64,$A0,$F1,$C0,$00,$01,$04,$88
 .db $88,$01,$E3,$42,$54,$A1,$99,$1E,$3C,$01,$04,$88
 .db $64,$00,$01,$C3,$9C,$A1,$09,$11,$23,$81,$64,$88
 .db $62,$00,$00,$41,$8C,$A1,$09,$11,$20,$61,$24,$88
 .db $81,$00,$02,$40,$04,$3E,$F1,$D9,$A0,$21,$24,$88
 .db $81,$00,$03,$40,$91,$00,$03,$6F,$EF,$E0,$EE,$66
 .db $6E,$00,$01,$C0,$91,$00,$15
.end
